;; -*- emacs-lisp -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; $Id: emacs_w3.el,v 1.9 2004/02/15 15:48:51 rscholz Exp $
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Einstellungen fr den W3-Mode und browse-url
;;
;; Die offizielle Quelle dieser Datei ist
;;   <http://www.zonix.de/html40/linux/emacsgnus.html>
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; W3 Mode
;; Eigene Stylesheets koennen nach ~/.w3 installiert werden
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(add-to-list 'load-path (concat zonix-elisp-dir "w3/lisp"))

(autoload 'w3 "w3" "WWW Browser" t)

(global-set-key "\C-c3" 'w3-follow-url-at-point)
(global-set-key "\C-cb" 'w3-preview-this-buffer)
(global-set-key "\C-cf" 'w3-fetch)
(global-set-key "\C-ch" 'w3-show-hotlist)

(setq w3-reuse-buffers 'always)
(setq w3-maximum-line-length 79)

(setq w3-user-colors-take-precedence t)
(setq w3-honor-stylesheets nil)
(setq w3-use-terminal-characters t)
(setq w3-use-terminal-characters-on-tty t)
(setq w3-horizontal-rule-char 45)
(setq w3-display-frames t)
(setq w3-do-incremental-display t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Browse-URL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; immer das gleiche Fenster benutzen
(setq browse-url-new-window-flag nil)

;; Stand-Alone Navigator
(setq browse-url-netscape-program "navigator")

;; Console -> W3 mode
(if (not (eq window-system 'x))
    (setq browse-url-browser-function 'browse-url-w3))

(global-set-key "\C-cu." 'browse-url-at-point)
(global-set-key "\C-cub" 'browse-url-of-buffer)
(global-set-key "\C-cuf" 'browse-url-of-file)
(global-set-key "\C-cun" 'browse-url-netscape)

(add-hook 'dired-mode-hook
	  (lambda ()
	    (local-set-key "\C-cuf" 'browse-url-of-dired-file)))

(if (boundp 'browse-url-browser-function)
    (global-set-key "\C-cuu" browse-url-browser-function)
  (eval-after-load
   "browse-url"
   '(global-set-key "\C-cuu" browse-url-browser-function)))

(add-hook 'browse-url-of-file-hook 'browse-url-netscape-reload)

(setq browse-url-save-file t)

;; (eval-after-load "w3"
;;   '(progn
;;     (fset 'w3-fetch-orig (symbol-function 'w3-fetch))
;;     (defun w3-fetch (&optional url target)
;;       (interactive (list (w3-read-url-with-default)))
;;       (if (eq major-mode 'gnus-article-mode)
;; 	  (browse-url-netscape url t)
;; 	(w3-fetch-orig url target)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; w3m im XTerm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; by Norbert Koch in <vzitkmmlja.fsf@lamia.LF.net>
(defun browse-url-w3m-xterm (url &optional new-window)
  ;; new-window ignored
  "Ask the W3M WWW browser to load URL.
Default to the URL around or before point.  A new w3m process is run
in an Xterm window using the Xterm program named by `browse-url-xterm-program'
with possible additional arguments `browse-url-xterm-args'."
  (interactive (browse-url-interactive-arg "Lynx URL: "))
  (apply #'start-process `(,(concat "w3m" url) nil ,browse-url-xterm-program
                           ,@browse-url-xterm-args "-e" "w3m" "-M" ,url)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Galeon
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Tabs
(setq browse-url-galeon-new-window-is-tab t)
(setq browse-url-new-window-flag t)

(setq browse-url-browser-function '(("^mailto:" . browse-url-mail)
				    ("." . browse-url-galeon)))

;; by Norbert Koch: unter X Galeon, auf der Console w3m
(defun nk-browser-func (url &optional new-window)
  (if (and (fboundp 'device-type) (equal (device-type) 'x))
      (browse-url-galeon url new-window)
    (w3m-browse-url url new-window)))
;(setq browse-url-browser-function 'nk-browser-func)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Remote-Browser
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; ,----[ browse-url-remote ]
;; | #!/bin/sh
;; | FLY=`/usr/sbin/arp | grep fly | awk '{print $1}'`
;; | ssh -X $FLY "/opt/gnome/bin/galeon -n $*"
;; `----


(setq browse-url-generic-program "browse-url-remote")

(setq browse-url-browser-function '(("^mailto:" . browse-url-mail)
				    ("." . browse-url-generic)))


